; This program blinks with the port bit P1.3 (pin 30 on the 8048, check
; with a logic probe).  If it works, the following parts work at least
; in some way:
;
; Address latch
; Address multiplexer
; ROM
; /CRD signal generation
;
; This program can be run from ROM or RAM.

; /usr/frankenstein/bin/as8048 -o blink_p13.hex -l blink_p13.list blink_p13.asm
;
; P1.0: enable multiplexer, active low
; P1.1: A17 for code access
; P1.2: A17 for data access
; P1.3: A16 for data access
; P1.4-P1.7: A12-A15 for code access
;
; P2.0-P2.7: A8-A15 for data access

		org 0
repeat
;
; light
;
		anl p1,#3		; a16data=1 a17data=0 a17code=* mux=*
		orl p1,#8

		call delay
;
; clear
;
	        anl p1,#3		; a16data=0 a17data=0 a17code=* mux=*

		call delay

		jmp repeat

delay
	        mov r1,#128
delay_2
	        mov r0,#128
delay_1
	        nop
	        nop
	        djnz r0,delay_1
	        djnz r1,delay_2
		ret
