: get-packedbcd ( nack -- n )
  i2c-getbyte
  DUP 15 AND >R         \ highnibble  R: ones
  4 RSHIFT              \ tens  R: ones
  10 * R> +             \ binary
;

: ds1307-get-time ( -- data )
  i2c-start
  [ HEX ] d0 [ DECIMAL ] i2c-putbyte  \ I2C address D0 | W
  DROP
  0 i2c-putbyte                       \ reset register pointer
  DROP
  i2c-stop
  i2c-start
  [ HEX ] d1 [ DECIMAL ] i2c-putbyte  \ I2C address D0 | R
  DROP
  0 get-packedbcd                     \ seconds
  0 get-packedbcd                     \ minutes
  0 get-packedbcd                     \ hours
  0 get-packedbcd >R                  \ wday
  0 get-packedbcd                     \ day
  0 get-packedbcd                     \ month
  1 get-packedbcd                     \ yy
  R>
  i2c-stop
  toyyyy
;

: put-packedbcd ( byte -- nack )
  10 /MOD 4 LSHIFT OR
  i2c-putbyte
;

: ds1307-set-time (  -- )
  fromyyyy SWAP >R SWAP >R SWAP >R >R >R >R
  i2c-start
  [ HEX ] d0 [ DECIMAL ] i2c-putbyte
  DROP
  0 i2c-putbyte
  DROP
  put-packedbcd DROP                  \ seconds, implicitly start clock
  R> put-packedbcd DROP               \ minutes
  R> put-packedbcd DROP               \ hours, implicitly use 24h mode
  R> put-packedbcd DROP               \ wday
  R> put-packedbcd DROP               \ day
  R> put-packedbcd DROP               \ month
  R> put-packedbcd DROP               \ yy
  i2c-stop
;
