; Serial test program: Enable receive data interrupt and echo
; received characters.
;
; /usr/frankenstein/bin/as8048 -o echo.hex -l echo.list echo.asm
;
; P1.0: enable multiplexer, active low
; P1.1: A17 for code access
; P1.2: A17 for data access
; P1.3: A16 for data access
; P1.4-P1.7: A12-A15 for code access
;
; P2.0-P2.7: A8-A15 for data access

	        org 0
	        jmp reset
		org 3
		jmp interrupt
		org 7
		nop

reset		mov a,#$80		; A15-A8 for data access (UART)
		outl p2,a
		mov r1,#0

		mov a,#$01		; Turn on interrupts
		mov r0,#1		; in UART register 1
		movx @r0,a

		en i

loop
		jmp loop

interrupt	
		mov r0,#0		; UART register 0
		movx a,@r0		; read character
		movx @r0,a		; and echo it
		retr
